% $Id: ResampleState.tex,v 1.1 2001/04/02 20:36:59 Philip.Charlton Exp $
\input Head

\section{\texttt{ResampleState}}

% A short (preferably one-line) description of {\tt MyClass}.

\texttt{ResampleState} --- holds the complete state of a \texttt{Resample}
object. 

\subsection{Description}

% A longer description of what {\tt MyClass} is used for.

\texttt{ResampleState} objects hold the complete state information of a
\texttt{Resample} object. A \texttt{Resample} object constructed from a
\texttt{ResampleState\/} object is identical in all respects to the object
from which the \texttt{ResampleState} was extracted. Through this
mechanism, a single sequence can be resmpled in segments, with each
segment processed by a different job, as if the entire sequence were
resampled all in one go. 

\subsection{Operating Instructions}

\subsubsection{Example Usage}

% A verbatim block of example code showing proper usage of {\tt
% MyClass}.
\begin{quote}
\footnotesize
\begin{verbatim}
#include "ResampleState.hh"
#include "Resample.hh"

int p;
int q;
int n;
double beta;
.
.
.
// Extract from a Resample object

Resample rsmpl(p,q,n,beta);
ResampleState state(rsmpl.getState());

// Create directly from resample ratio, anti-aliasing filter params
ResampleState stateA(p,q,n,beta);

// input x is, e.g., std::valarray<complex<float> >
std::valarray<complex<float> > xa;
std::valarray<complex<float> > xb;
std::valarray<complex<float> > y;
std::valarray<complex<float> > ya;
std::valarray<complex<float> > yb;
std::valarray<complex<float> > ybb;

xa.resize(100);
xa = x(slice(0,100,1));           // first part x
xb.resize(100);
xb = x(slice(100,100,1));         // second part x

rsmpl.apply(y,x);                 // filter all of x

Resample rsmplA(p,q,n,beta);
rsmplA.apply(ya,xa);              // filter first 100 elements x

ResampleState stateA;
rsmplA.getState(stateA);
Resample rsmplB(stateA);          // new Resample object w/state of rsmplA

rsmplB.apply(yb,xb);
rsmplA.apply(ybb,xb);

// ya is exactly equal to y(slice(0,100,1));
// ybb, yb are exactly equal to y(slice(100,100,1));
\end{verbatim}
\end{quote}

\subsubsection{Options/Defaults}

% A list of options or defaults for public methods or member data of
% {\tt MyClass}. 

\subsection{Exceptions}

\subsubsection{Exceptions Thrown}

% A list of exceptions thrown by {\tt MyClass}.


\subsubsection{Exceptions Handled}

% A list of exceptions handled by {\tt MyClass}.

None.

\subsection{Algorithms}

% A discussion of the algorithms used by {\tt MyClass}.

\subsection{Accuracy}

% A discussion of issues related to the accuracy of numerical routines
% used by {\tt MyClass}---e.g., approximations,  argument ranges, etc.

\subsection{Performance}

% A discussion of issues related to the speed (e.g., $O(N\log N)$) of
% computationally demanding routines used by {\tt MyClass}.

\subsection{Testing}

% A description of any test code/test classes that were used to test
% {\tt MyClass}. 

\texttt{ResampleState} is tested as part of the \texttt{Resample} test
suite \texttt{tResample}.

\subsection{Notes}

% Miscellaneous notes about {\tt MyClass} that do not appear
% elsewhere, things that remain to be done, etc.  

\subsection{See Also}

% A list of derived classes, base classes, etc.\ closely related to
% {\tt MyClass}. 

\begin{itemize}
\item \texttt{Resample} (a friend class)
\end{itemize}

\subsection{References}

% A list of references for any algorithms, etc.\ used by {\tt
% MyClass}. 

\input Tail

%%% Local Variables: 
%%% mode: latex
%%% TeX-master: "datacondAPI"
%%% End: 
